; ##############################################################################
; ##############################################################################
; ##############################################################################
; Power-Down, Resetting and Clearing the AD9835									
; D15 = 1																		
; D14 = 1																		
; D13 = SLEEP																	
; D12 = RESET																	
; D11 = CLR																		
DDS_OFF:
	ldi temp1,0xF8				; 'Reset
	ldi temp2,0x00
	rcall DDS_DATA_TEMP1_2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DDS_ON:
	ldi temp1,0xC0 			;Reset end
	ldi temp2,0x00
	rcall DDS_DATA_TEMP1_2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DDS_SYNCHRON:
	ldi temp1,0x80 				;'Sync
	ldi temp2,0x00
	rcall DDS_DATA_TEMP1_2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DDS_INITIALISIERUNG:

	rcall DDS_OFF

	ldi temp1,0x30 				;4 Bytes (1kHZ)
	ldi temp2,0x8B
	rcall DDS_DATA_TEMP1_2

	ldi temp1,0x21
	ldi temp2,0x4F
	rcall DDS_DATA_TEMP1_2

	ldi temp1,0x32
	ldi temp2,0x01
	rcall DDS_DATA_TEMP1_2

	ldi temp1,0x23
	ldi temp2,0x00
	rcall DDS_DATA_TEMP1_2

	rcall DDS_SYNCHRON

	rcall DDS_ON

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; WERT=f(out) x 2^32          / 50.000.000										
; WERT=f(out) x 4.294.967.296 / 50.000.000										
; WERT=f(out) x 2.882.303.762 / 33.554.432										
; WERT=f(out) x 2.882.303.762 / 2^25											
;																				
DDS_FREQUENZ:
	; Multiplikation		
	LDS temp1,(adr_FREQUENZ_BYTE0)
	LDS temp2,(adr_FREQUENZ_BYTE1)
	LDS temp3,(adr_FREQUENZ_BYTE2)
	LDS temp4,(adr_FREQUENZ_BYTE3)

	ldi temp5,BYTE1(2882303762)
	ldi temp6,BYTE2(2882303762)
	ldi temp7,BYTE3(2882303762)
	ldi temp8,BYTE4(2882303762)
	rcall FUNKTION_MULTIPLIKATION_32_32
	; Division				
	ldi temp,25
DDS_FREQUENZ_s:
	LSR temp8
	ROR temp7
	ROR temp6
	ROR temp5
	ROR temp4
	ROR temp3
	ROR temp2
	ROR temp1
	dec temp
	brne DDS_FREQUENZ_s
	; Ergebnis im SRAM speichern	
	STS(adr_DDS_BYTE0),temp1
	STS(adr_DDS_BYTE1),temp2
	STS(adr_DDS_BYTE2),temp3
	STS(adr_DDS_BYTE3),temp4


	; Bytes senden					
	ldi temp1,0x30 				;4 Bytes to FREQ0
	LDS temp2,(adr_DDS_BYTE0)
	rcall DDS_DATA_TEMP1_2

	ldi temp1,0x21
	LDS temp2,(adr_DDS_BYTE1)
	rcall DDS_DATA_TEMP1_2

	ldi temp1,0x32
	LDS temp2,(adr_DDS_BYTE2)
	rcall DDS_DATA_TEMP1_2

	ldi temp1,0x23
	LDS temp2,(adr_DDS_BYTE3)
	rcall DDS_DATA_TEMP1_2

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DDS_DATA_TEMP1_2:
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR				; GELB an		
	cbi (SPI_CS_PORT),(SPI_CS_PIN_NR)				; CS auf LOW	
	mov temp,temp1
	rcall SPI_DATA_TEMP
	mov temp,temp2
	rcall SPI_DATA_TEMP
	sbi (SPI_CS_PORT),(SPI_CS_PIN_NR)				; CS auf HIGH	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR				; GELB aus		
	rcall DDS_WAIT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DDS_WAIT:
	nop
	nop
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

