; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; LCD 2x16 4x16 4x20 ZEICHEN													
;																				
; LCD-INITIALISIERUNG															
LCD_INITIALISIERUNG:
	; auf LOW				
	cbi (LCD_DATA0_PORT),(LCD_DATA0)
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
	cbi (LCD_E_PORT),(LCD_E)
	cbi (LCD_RS_PORT),(LCD_RS)
	; auf Ausgang			
	sbi (LCD_DATA0_DDR),(LCD_DATA0)
	sbi (LCD_DATA1_DDR),(LCD_DATA1)
	sbi (LCD_DATA2_DDR),(LCD_DATA2)
	sbi (LCD_DATA3_DDR),(LCD_DATA3)
	sbi (LCD_RS_DDR),(LCD_RS)
	sbi (LCD_E_DDR),(LCD_E)
	; INITIALISIERUNG		
    cbi (LCD_RS_PORT),(LCD_RS) 			; RS aus (low)				
	sbi (LCD_DATA0_PORT),(LCD_DATA0)  	; x03 muss 3mal hintereinander gesendet werden zur Initialisierun
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	rcall LCD_ENABLE					; 1	
	rcall LCD_ENABLE					; 2	
	rcall LCD_ENABLE					; 3	
    ldi temp, 0b00000010        ;4bit-Modus einstellen
	rcall LCD_COMMAND
    ldi temp, 0b00000001        ; DISPLAY lschen			
 	rcall LCD_COMMAND
    ldi temp, 0b00001111        ; DISPLAY ein / CURSOR blinken
	rcall LCD_COMMAND
    ldi temp, 0b00000110        ; Cursor Auto-Increment
 	rcall LCD_COMMAND
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																		  
;erzeugt den Enable-Puls												  
;																		  
LCD_ENABLE:
	sbi LCD_E_PORT, LCD_E    		   	; Enable high		
 	rcall wait_5us            		  	; kurze PAUSE		
	cbi LCD_E_PORT, LCD_E     		  	; Enable low		
	rcall wait_50us            		 	; kurze PAUSE		
ret                          
; ##############################################################################
; ##############################################################################
; ##############################################################################
; sendet ein Datenbyte an das LCD										  		
;																		  		
; INPUT: temp															  		
;																		  		
; rcall LCD_DATA			; DATENBYTE an LCD inp: temp 				  		
;																		  		
LCD_DATA:
	sbi LCD_RS_PORT, LCD_RS 			; RS ein/auf DATA (high)				
LCD_DATA_RS:
	cbi (LCD_DATA0_PORT),(LCD_DATA0)	; alle auf LOW							
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	SBRC temp,4							; SPRUNG, wenn BIT clear				
	sbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRC temp,5
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRC temp,6
	sbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRC temp,7
	sbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	rcall lcd_enable        			; Enable-Routine aufrufen				
;-------------------------------------------------------------------------------
	cbi (LCD_DATA0_PORT),(LCD_DATA0)	; auf LOW								
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	SBRC temp,0							; SPRUNG, wenn BIT clear				
	sbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRC temp,1
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRC temp,2
	sbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRC temp,3
	sbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	rcall lcd_enable        			; Enable-Routine aufrufen				
	rcall wait_5us						; Pause 								
	sbi LCD_RS_PORT, LCD_RS 			; vorsichtshalber RS ein/auf DATA (high)
ret				                       
; ##############################################################################
; ##############################################################################
; ##############################################################################
;sendet einen Befehl an das LCD;wie lcd_data, nur ohne RS zu setzen		  		
;																		  		
; INPUT: temp															  		
;																		  		
LCD_COMMAND:                            
    cbi (LCD_RS_PORT),(LCD_RS) 			;	 RS aus (low)				
	rcall LCD_DATA_RS
	rcall wait_5ms						; Pause (wichtig)				
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Display lschen														  		
LCD_CLEAR:
   	ldi temp, 0b00000001
    rcall lcd_command
	rcall LCD_ZEILE1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KURSOR GO-HOME														  		
LCD_ZEILE1:
 	ldi temp, 0b00000010
	rcall lcd_command 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KURSOR Sprung in ZEILE2												  		
LCD_ZEILE2:
 	ldi temp, 0b11000000 
	rcall lcd_command 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KURSOR Sprung in ZEILE3														
LCD_ZEILE3:
	ldi temp, 0b10010100  	; LCD 4x20	
	;ldi temp, 0b10010000 	; LCD 4x16	
	rcall lcd_command 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KURSOR Sprung in ZEILE4												  		
LCD_ZEILE4:
	ldi temp, 0b11010100	; LCD 4x20	
	;ldi temp, 0b11010000 	; LCD 4x16	
	rcall lcd_command 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_SPACE:
	ldi temp, ' '		; SPACE
	rcall LCD_DATA	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_PUNKT:
	ldi temp, '.'		; PUNKT
	rcall LCD_DATA	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_3_PUNKT:
	ldi temp, '.'		; PUNKT
	rcall LCD_DATA	
	rcall LCD_DATA	
	rcall LCD_DATA	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_DOPPEL_PUNKT:
	ldi temp, ':'		; DOPPELPUNKT
	rcall LCD_DATA	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	brne ANZEIGE_TEXT_w
	ret
ANZEIGE_TEXT_w:
	rcall LCD_DATA			; Anzeige
	rjmp ANZEIGE_TEXT
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1																	
; OUT: (z.B."FF") 																
;																				
; rcall ANZEIGE_HEX_TEMP1 ; inp: temp1											
;																				
ANZEIGE_HEX_TEMP1:
	; SICHERUNGSKOPIE						
	push temp
	push temp1
	; oberes NIBBLE bearbeiten				
	mov temp,temp1	
	swap temp						; NIBBLES tausch	
	rcall ANZEIGE_HEX_UMWANDLUNG	; INP/OUT: temp		
	rcall LCD_DATA					; ANZEIGE			
	; unteres NIBBLE bearbeiten				
	mov temp,temp1	
	rcall ANZEIGE_HEX_UMWANDLUNG	; INP/OUT: temp		
	rcall LCD_DATA					; ANZEIGE			
	; SICHERUNGSKOPIE wieder herstellen		
	pop temp1
	pop temp
	ret
;-------------------------------------------------------------------------------
ANZEIGE_HEX_UMWANDLUNG:
	; BITMUSTER	
	andi temp,0b00001111
	; vergleich	
	cpi temp,10
	brsh ANZEIGE_HEX_UMWANDLUNG_A_F
ANZEIGE_HEX_UMWANDLUNG_0_9:
	subi temp,-48
	ret
ANZEIGE_HEX_UMWANDLUNG_A_F:
	subi temp,-48-7
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "123"														  	  	      
AUSGABE_ZAHL_3_STELLEN_FORMATIERT_TEMP1:
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32
	rcall FUNKTION_FORMAT
	rcall AUSGABE_ZAHL_3_ZEICHEN_KURZ
	rcall LCD_SPACE
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; "1.234"														  	  	  
AUSGABE_ZAHL_5_STELLEN_FORMATIERT_TEMP1_2:
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32
	rcall FUNKTION_FORMAT
	rcall AUSGABE_ZAHL_6_ZEICHEN_KURZ
	rcall LCD_SPACE
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; "12.345.678"														  	  
AUSGABE_ZAHL_8_STELLEN_FORMATIERT_TEMP1_3:
	clr temp4
	rcall FUNKTION_HEX_ASC_32
	rcall FUNKTION_FORMAT
	rcall AUSGABE_ZAHL_10_ZEICHEN_KURZ
	rcall LCD_SPACE
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; "1.234.567.890"														  
AUSGABE_ZAHL_10_STELLEN_FORMATIERT_TEMP1_4:
	rcall FUNKTION_HEX_ASC_32
	rcall FUNKTION_FORMAT
	rcall AUSGABE_ZAHL_13_ZEICHEN_KURZ
	rcall LCD_SPACE
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
AUSGABE_ZAHL_13_ZEICHEN_KURZ:
	mov temp, YH			; 11.ZEICHEN 
	rcall LCD_DATA
AUSGABE_ZAHL_12_ZEICHEN_KURZ:
	mov temp, YL			; 11.ZEICHEN 
	rcall LCD_DATA
AUSGABE_ZAHL_11_ZEICHEN_KURZ:
	mov temp, XH			; 11.ZEICHEN 
	rcall LCD_DATA
AUSGABE_ZAHL_10_ZEICHEN_KURZ:
	mov temp, XL			; 10.ZEICHEN 
	rcall LCD_DATA
AUSGABE_ZAHL_9_ZEICHEN_KURZ:
	mov temp, temp9			; 9.ZEICHEN 
	rcall LCD_DATA
AUSGABE_ZAHL_8_ZEICHEN_KURZ:
	mov temp, temp8			; 8.ZEICHEN 
	rcall LCD_DATA
AUSGABE_ZAHL_7_ZEICHEN_KURZ:
	mov temp, temp7			; 7.ZEICHEN 
	rcall LCD_DATA
AUSGABE_ZAHL_6_ZEICHEN_KURZ:
	mov temp, temp6			; 6.ZEICHEN 
	rcall LCD_DATA
AUSGABE_ZAHL_5_ZEICHEN_KURZ:
	mov temp, temp5			; 5.ZEICHEN 
	rcall LCD_DATA
AUSGABE_ZAHL_4_ZEICHEN_KURZ:
	mov temp, temp4			; 4.ZEICHEN 
	rcall LCD_DATA
AUSGABE_ZAHL_3_ZEICHEN_KURZ:
	mov temp, temp3			; 3.ZEICHEN 
	rcall LCD_DATA
AUSGABE_ZAHL_2_ZEICHEN_KURZ:
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA
AUSGABE_ZAHL_1_ZEICHEN_KURZ:
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall LCD_DATA
ret
;######################################################################## 	
;######################################################################## 	
;######################################################################## 	
; formatiert die LCD AUSGABE mit 1000-er Punkt								
; 	Bsp. "00012345 => "1.234.567.890"										
;	INPUT: TEMP1															
;	INPUT: TEMP2															
;	INPUT: TEMP3															
;	INPUT: TEMP4															
;	INPUT: TEMP5															
;	INPUT: TEMP6															
;	INPUT: TEMP7															
;	INPUT: TEMP8															
;	INPUT: TEMP9															
;	INPUT: XL																
;																			
;	OUPUT: TEMP1															
;	OUPUT: TEMP2															
;	OUPUT: TEMP3															
;	OUPUT: TEMP4															
;	OUPUT: TEMP5															
;	OUPUT: TEMP6															
;	OUPUT: TEMP7															
;	OUPUT: TEMP8															
;	OUPUT: TEMP9															
;	OUPUT: XL																
;	OUPUT: XH																
;	OUPUT: YL																
;	OUPUT: YH																
FUNKTION_FORMAT:
	; zuordnen			
	mov YH,XL
	ldi YL,'.'
	mov XH,temp9
	mov XL,temp8
	mov temp9,temp7
	ldi temp8,'.'
	mov temp7,temp6
	mov temp6,temp5
	mov temp5,temp4
	ldi temp4,'.'
	; vergleich/ersetzen		
	cpi YH,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi YH,'_'
	ldi YL,'_'
	; vergleich/ersetzen		
	cpi XH,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi XH,'_'
	; vergleich/ersetzen		
	cpi XL,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi XL,'_'
	; vergleich/ersetzen		
	cpi temp9,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi temp9,'_'
	ldi temp8,'_'
	; vergleich/ersetzen		
	cpi temp7,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi temp7,'_'
	; vergleich/ersetzen		
	cpi temp6,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi temp6,'_'
	; vergleich/ersetzen		
	cpi temp5,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi temp5,'_'
	ldi temp4,'_'
	; vergleich/ersetzen		
	cpi temp3,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi temp3,'_'
	; vergleich/ersetzen		
	cpi temp2,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi temp2,'_'
	; vergleich/ersetzen		
	cpi temp1,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi temp1,'_'
FUNKTION_FORMAT_FERTIG:
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; STAND: 01.12.2013															
;																			
;	Value: 0...	4.294.967.295												
;																			
;	INPUT: 	temp1	(BYTE1)													
;	 		temp2	(BYTE2)													
;			temp3	(BYTE3)													
;			temp4	(BYTE4)													
;																			
;	OUTPUT:	temp1	(		     1-er Stelle)								
;			temp2	(		    10-er Stelle)								
;			temp3	(          100-er Stelle)								
;			temp4	(        1.000-er Stelle)								
;			temp5	(       10.000-er Stelle)								
;			temp6	(      100.000-er Stelle)								
;			temp7	(    1.000.000-er Stelle)								
;			temp8	(   10.000.000-er Stelle)								
;			temp9	(  100.000.000-er Stelle)								
;			XL		(1.000.000.000-er Stelle)								
; 																			
FUNKTION_HEX_ASC_32:
	clr XL
FUNKTION_HEX_ASC_109:	; 1.000.000.000
	inc XL
	subi temp1, BYTE1    (1000000000)
	sbci temp2, BYTE2    (1000000000)
	sbci temp3, BYTE3    (1000000000)
	sbci temp4, BYTE4    (1000000000)
	brcc FUNKTION_HEX_ASC_109
	subi XL, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-1000000000)
	sbci temp2, BYTE2   (-1000000000)
	sbci temp3, BYTE3   (-1000000000)
	sbci temp4, BYTE4   (-1000000000)
;---------------------------------------------------------------------------
	clr temp9			
FUNKTION_HEX_ASC_108:	; 100.000.000
	inc temp9
	subi temp1, BYTE1    (100000000)
	sbci temp2, BYTE2    (100000000)
	sbci temp3, BYTE3    (100000000)
	sbci temp4, BYTE4    (100000000)
	brcc FUNKTION_HEX_ASC_108
	subi temp9, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-100000000)
	sbci temp2, BYTE2   (-100000000)
	sbci temp3, BYTE3   (-100000000)
	sbci temp4, BYTE4   (-100000000)
;---------------------------------------------------------------------------
	clr temp8
FUNKTION_HEX_ASC_107:	; 10.000.000
	inc temp8
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNKTION_HEX_ASC_107
	subi temp8, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
;---------------------------------------------------------------------------
	clr temp7
FUNKTION_HEX_ASC_106:	; 1.000.000
	inc temp7
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNKTION_HEX_ASC_106
	subi temp7, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
;---------------------------------------------------------------------------
	clr temp6
FUNKTION_HEX_ASC_105:	; 100.000	
	inc temp6
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_105
	subi temp6, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
;---------------------------------------------------------------------------	clr temp
	clr temp5
FUNKTION_HEX_ASC_104:	; 10.000	
	inc temp5
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNKTION_HEX_ASC_104
	subi temp5, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
;---------------------------------------------------------------------------
	clr temp4
FUNKTION_HEX_ASC_103:	; 1.000		
	inc temp4
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_103
	subi temp4, (-48+1)	; HEX->ASC	
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
;---------------------------------------------------------------------------
	clr temp3
FUNKTION_HEX_ASC_102:	; 100		
	inc temp3
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_102
	subi temp3, (-48+1)	; HEX->ASC	
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
;---------------------------------------------------------------------------
	clr temp2
FUNKTION_HEX_ASC_101:	; 10		
	inc temp2
	subi temp1, low  (10)
	brcc FUNKTION_HEX_ASC_101
	subi temp2, (-48+1)	; HEX->ASC	
	subi temp1, low  (-10)
;---------------------------------------------------------------------------
FUNKTION_HEX_ASC_100:	; 1			
	subi temp1, -48		; HEX->ASC	
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 
